## 19.1 WOT Function
When WOT is enabled (RCOSC_E=1, WORE=1 and WMODE=1), A7169 periodically wakes up from sleep and transmit (auto-enter TX mode) packet with TX FIFO contents without MCU interaction. While WN=0, A7169 will stay in sleep mode based on WOR_SL timer and enter TX mode to transmit one TX packet then return to sleep mode for next cycle. While WN≥1, that is, A7169 will send (WN+1) TX packets after waking up. WOR_AC timer defines the gap period between two TX packets. SPSS (08h, page 4) is used to set the return Mode between Standby mode (SPSS=0) and PLL mode (SPSS=1) while WN≥1. See figure below:

## 19.1 WOT功能
当WOT启用时（RCOSC_E=1，WORE=1，WMODE=1），A7169会定期从睡眠中唤醒，并在没有MCU交互的情况下传输（自动进入TX模式）包含TX FIFO内容的数据包。当WN=0时，A7169将根据WOR_SL定时器保持睡眠模式，并进入TX模式发送一个TX数据包，然后返回睡眠模式进行下一个周期。当WN≥1时，即A7169在唤醒后将发送（WN+1）TX数据包。WOR_AC定时器定义了两个TX数据包之间的间隔时间。当WN≥1时，使用SPSS（08h，第4页）在待机模式（SPSS=0）和PLL模式（SPSS=1）之间设置返回模式。请参见下图：

## 19.2 WOR Function
When WOR is enabled (RCOSC_E=1, WORE=1, WMODE=0 and TWSOE=0), A7169 periodically wakes up from sleep and listen (auto-enter RX mode) for incoming packets without MCU interaction. Therefore, A7169 will stay in sleep mode based on WOR_SL timer and RX mode based on WOR_AC timer unless a packet is received. While MCU starts WOR function, the device goes to RX mode to check coming packets after a period (WOR_SL) in sleep mode. And then, A7169 is back to sleep mode for the next WOR cycle. Beware, please turn on MSCRC (0Eh, CRC data filtering) when CRCS=1 (08h, page 14, CRC select) in WOR function. 
There are three ways to activate WOR packet receiving procedure: by frame sync (ID matched), by preamble and by
carrier. It is the way to define that RX circuitry will start to receive data according to frame sync signal (FSYNC) or preamble signal (PMDO) or carrier signal (CD) when a packet is coming during one active RX period under WOR mode. User could select this WOR activated way by setting [WOR_CD (08h, page 2), WOR_S (08h, page 2)].
(1) WOR by FSYNC ([WOR_CD, WOR_S]=[00]): If FSYNC (packet ID matched) goes high during WOR RX period, RX circuitry will stay turn on until the whole packet is received.
(2) WOR by PMDO ([WOR_CD, WOR_S]=[01]): If PMDO (preamble detected) goes high during WOR RX period, RX circuitry will stay turn on until the whole packet is received.
(3) WOR by CD ([WOR_CD, WOR_S]=[1x]): If CD (carrier detected) goes high during WOR RX period, RX circuitry will stay turn on until the whole packet is received. CDSEL has to be set to [11] for CD signal composed of RSSI and in-band carrier detect signal.
After RX receiving procedure is done, A7169 will acknowledge MCU this event by using TWOR signal. User could also let MCU know this event by FSYNC/PMDO/CD according to which activating way he is using and waked up in advance to wait for RX receiving procedure finished. While WN≥1, A7169 will also have repeated (WN+1) RX times between two WOR_SL period. The active and RX to RX space time are both decided by WOR_AC. The SPSS also defines the return state in this repeated (WN+1) RX scheme.

## 19.2 WOR功能
激活WOR数据包接收过程有三种方法：通过帧同步（ID匹配）、通过前导码和通过
承运人。这是定义在WOR模式下，当数据包在一个活动RX时段内到来时，RX电路将根据帧同步信号（FSYNC）或前导信号（PMDO）或载波信号（CD）开始接收数据的方法。用户可以通过设置[WOR_CD（08h，第2页）、WOR_S（08h），选择此WOR激活方式]。
- （1） WOR by FSYNC（[WOR_CD，WOR_S]=[00]）：如果FSYNC（数据包ID匹配）在WOR RX期间变高，RX电路将保持开启状态，直到接收到整个数据包。
- （2） WOR by PMDO（[WOR_CD，WOR_S]=[01]）：如果在WOR RX期间PMDO（检测到前导码）变高，RX电路将保持开启状态，直到接收到整个数据包。
- （3） WOR by CD（[WOR_CD，WOR_S]=[1x]）：如果在WOR RX期间CD（检测到的载波）变高，RX电路将保持开启状态，直到接收到整个数据包。对于由RSSI和带内载波检测信号组成的CD信号，CDSEL必须设置为[11]。
  
RX接收过程完成后，A7169将使用TWOR信号确认MCU此事件。用户还可以根据自己使用的激活方式，通过FSYNC/PMDO/CD让MCU知道此事件，并提前唤醒等待RX接收过程完成。当WN≥1时，A7169在两个WOR_SL周期之间也将重复（WN+1）次RX。活动和RX到RX的空时都由WOR_AC决定。SPSS还定义了这种重复的（WN+1）RX方案中的返回状态。
当WOR启用时（RCOSC_E=1，WORE=1，WMODE=0和TWSOE=0），A7169会定期从睡眠中唤醒，并在没有MCU交互的情况下监听（自动进入RX模式）传入的数据包。因此，除非收到数据包，否则A7169将基于WOR_SL定时器保持睡眠模式，基于WOR_AC定时器保持RX模式。当MCU启动WOR功能时，设备在睡眠模式下经过一段时间（WOR_SL）后进入RX模式检查即将到来的数据包。然后，A7169在下一个WOR周期回到睡眠模式。请注意，在WOR功能中，当CRCS=1（08h，第14页，CRC选择）时，请打开MSCRC（0Eh，CRC数据过滤）。

## 19.3 TWOR Function
The RC oscillator inside A7169 can also be used to supports programmable TWOR (Timer Wake On RX, RCOSC_E=1, WORE=1, WMODE=0 and TWSOE=1) function that enables A7169 to output a periodic square wave from GIO1 (or GIO2). The duty cycle of this square wave is set by WOR_AC (08h, page 1) or WOR_SL (08h, page 1) regarding to TSEL (08h, page 2). User can use this square wave to wake up MCU or other purposes.

## 19.3 TWOR功能
A7169内部的RC振荡器还可用于支持可编程的TWOR（定时器唤醒RX，RCOSC_E=1，WORE=1，WMODE=0和TWSOE=1）功能，使A7169能够从GIO1（或GIO2）输出周期性方波。关于TSEL（08h，第2页），该方波的占空比由WOR_AC（08h）（第1页）或WOR_SL（第一页，08h）设置。用户可以使用此方波唤醒MCU或其他目的。
