#ifndef _A7169CONFIG_433Mhz10kbps_h_
#define _A7169CONFIG_433Mhz10kbps_h_
#include <stdint.h>

uint16_t A7169Config_433Mhz10kbps[]=        //433MHz, 10kbps (IFBW = 50KHz, Fdev = 18.75KHz), Crystal=12.8MHz
{
    0x0803,     //SYSTEM CLOCK register,
    0x0821,     //PLL1 register,
    0xDA05,     //PLL2 register,    433.301MHz
    0x0000,     //PLL3 register,
    0x0A20,     //PLL4 register,
    0x0000,     //PLL5 register,
    0x0000,     //PLL6 register,
    0x0025,     //CRYSTAL register,
    0x0000,     //PAGEA,
    0x0000,     //PAGEB,
    0x18D0,     //RX1 register,     IFBW=50KHz  
    0x7009,     //RX2 register,     by preamble
    0x4000,     //ADC register,     
    0x0800,     //PIN CONTROL register,     Use Strobe CMD
    0x6C00,     //CALIBRATION register,
    0x20C0      //MODE CONTROL register,    Use FIFO mode
};

uint16_t A7169Config_PageA_433Mhz10kbps[]=   //433MHz, 10kbps (IFBW = 50KHz, Fdev = 18.75KHz), Crystal=12.8MHz
{
    0xF606,     //TX1 register,     Fdev = 18.75kHz
    0xFC00,     //WOR1 register,
    0xF811,     //WOR2 register,
    0x0907,     //RFI register,     Enable Tx Ramp up/down  
    0x8A10,     //PM register,      CST=1
    0x0303,     //RTH register,
    0x400F,     //AGC1 register,    
    0x0DC0,     //AGC2 register, 
    0x0001,     //GIO register,     GIO1=WTR
    0xFA01,     //CKO register
    0x0048,     //VCB register,
    0x6921,     //CHG1 register,    430MHz
    0x0F21,     //CHG2 register,    435MHz
    0x003F,     //FIFO register,    FEP=63+1=64bytes
    0x1507,     //CODE register,    Preamble=4bytes, ID=4bytes
    0x87E0      //WCAL register,
};

uint16_t A7169Config_PageB_433Mhz10kbps[]=   //433MHz, 10kbps (IFBW = 50KHz, Fdev = 18.75KHz), Crystal=12.8MHz
{
    0x0337,     //TX2 register,
    0x8200,     //IF1 register,     Enable Auto-IF, IF=100KHz
    0x0000,     //IF2 register,
    0x0000,     //ACK register,
    0x0000,     //ART register,
    0x3800,     //SYN register,
    0xF177,     //RCCAL register,
    0x0000,     //ACKFIFO register,
    0x0064,     //PNCFG1 register,
    0x0010,     //PNCFG2 register,
    0x0001,     //PNCFG3 register,
    0x0000,		  //PNCFG4 register,
    0x0001,     //PNCFG5 register,
    0x0000,     //TCODE register,
    0x0000,     //PN DC register,
    0x0036,     //PNCFG6 register,
    0x0C24,     //PNCFG7 register,
    0xA521,     //PNCFG8 register,
    0xF045,     //PNCFG9 register,
    0x003F,     //PNCFG10 register,
    0x4442,     //Misc_CFG1 register,
    0x0729,     //Misc_CFG2 register,
    0x0040,     //Misc_CFG3 register,
    0x0021,     //PLL7 register,
    0xDA05,     //PLL8 register,
    0x0000,     //PS MODE1 register,
    0x0000,     //PS MODE2 register,
    0x0000,     //PS MODE3 register,
    0x0000,     //TX3 register,
    0x0060,     //Misc_CFG4 register,
    0x0000,     //PNCFG11 register,
    0x0000,     //PNCFG12 register,
    0x0000,     //PNCFG13 register,
    0x0000,     //PNCFG14 register,
    0x0000,     //PNCFG15 register,
    0x0000,     //PNCFG16 register,
    0x0000,     //PNCFG17 register,
    0x000F,     //PNCFG18 register,
    0x0000,     //CSMA1 register,
    0x0000,     //CSMA2 register,
    0x0000,     //TXPA register,
    0x0000,     //DCMON1 register,
    0x0000,     //DCMON2 register,
    0x0000,     //DCMON3 register,
    0x0000,     //MBUS1 register,
    0x0000,     //MBUS2 register,
    0x0000,     //MBUS3 register,
    0x0000,     //MBUS4 register,
    0x0000,     //MBUS5 register,
    0x0000,     //PN DC2 register,
    0x0000,     //VCB2 register,
    0x0000,     //PS MODE4 register
    0x0000     	//WOR3 register
};
#endif
