
#ifndef __A7169_hal_H__
#define __A7169_hal_H__

#include "stdbool.h"
#include "stdint.h"
#include "myRadio_gpio.h"

typedef struct 
{
    uint16_t *config;
    uint16_t *pageA;
    uint16_t *pageB;
}A7169Config_ts;

extern A7169Config_ts A7169ConfigBuffer;
void A7169_delayMs(uint32_t time);
void A7169_delayUs(uint32_t time);
/*********************************************************************
** Strobe Command
*********************************************************************/
void StrobeCMD(uint8_t cmd);
/************************************************************************
**  A7169_WriteReg
************************************************************************/
void A7169_WriteReg(uint8_t address, uint16_t dataWord);
/************************************************************************
**  A7169_ReadReg
************************************************************************/
uint16_t A7169_ReadReg(uint8_t address);
/************************************************************************
**  A7169_WritePageA
************************************************************************/
void A7169_WritePageA(uint8_t address, uint16_t dataWord);
/************************************************************************
**  A7169_ReadPageA
************************************************************************/
uint16_t A7169_ReadPageA(uint8_t address);
/************************************************************************
**  A7169_WritePageB
************************************************************************/
void A7169_WritePageB(uint8_t address, uint16_t dataWord);
/************************************************************************
**  A7169_ReadPageB
************************************************************************/
uint16_t A7169_ReadPageB(uint8_t address);
/*********************************************************************
** A7169_POR
*********************************************************************/
void A7169_POR(void);
/*********************************************************************
** InitRF
*********************************************************************/
uint8_t InitRF(void);
/*********************************************************************
** A7169_Config
*********************************************************************/
uint8_t A7169_Config(void);
/************************************************************************
**  WriteID
************************************************************************/
uint8_t A7169_WriteID(void);
/*********************************************************************
** A7169_Cal
*********************************************************************/
uint8_t A7169_Cal(void);
/*********************************************************************
** A7169_WriteFIFO
*********************************************************************/
void A7169_WriteFIFO(void);
/*********************************************************************
** RxPacket
*********************************************************************/
void RxPacket(void);
void RxPacket_ReadFifo(uint8_t *fuffer, uint16_t len);
/*********************************************************************
** Err_State
*********************************************************************/
void Err_State(void);
/*********************************************************************
** entry_deep_sleep_mode
*********************************************************************/
void entry_deep_sleep_mode(void);
/*********************************************************************
** wake_up_from_deep_sleep_mode
*********************************************************************/
void wake_up_from_deep_sleep_mode(void);
/*********************************************************************
** BODF_Detect
*********************************************************************/
uint8_t BODF_Detect(void);
void A7169_FifoWrite(uint8_t *src, uint16_t len);
void A7169_SetConfig(A7169Config_ts config);
#endif //
